/*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.
 *    
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *    
 *  * Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  * Neither the name of Nokia Corporation nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *    
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 *    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *    
 *    Description: Nfc Share wrapper is used to send the user requests to engine.
 */


#ifndef NFCSHAREWRAPPER_H_
#define NFCSHAREWRAPPER_P_H_

// User Include Files.
#include "nfcsharewindow.h"
#include "nfcaiwengine.h"
#include "nfcshareconst.h"

/*
 * This wrapper class is used to send the User requests from the
 * UI to engine, and also to send the engine responses to UI through
 * wrapper signals.
 */
class NfcShareWrapper : public QObject
{
Q_OBJECT
    
public:
    NfcShareWrapper();
    ~NfcShareWrapper();
    void startSharingService(NfcSharingType aSharingType);
    void startEasySetupService();
    void stopService();

signals:
    void windowUpdated(QString updateInfo);

private:
    // Pointer to the AIW handler engine class.
    CNfcAiwEngine* mCNfcAiwEngine; 
    
private:    
    // Friend class definitions.
    friend class CNfcAiwEngine;
};
#endif /* NFCSHAREWRAPPER_H_ */
